<i18n lang="yml">
  en:
    no_results: "No search results..."
  nl:
    no_results: "Geen zoekresultaten..."
</i18n>

<template>
  <v-select
    v-model="inputValue"
    :options="options"
    :placeholder="placeholder"
    autocomplete="on"
    :no-drop="false"
    :components="{ OpenIndicator: openIndicator }"
    :class="['inputauto', variant]"
    @input="onInput"
  >
    <template #no-options="">
      <div :class="$style['no-results']">
        {{ $t("no_results") }}
      </div>
    </template>
  </v-select>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  Ref,
  watchEffect,
} from "@nuxtjs/composition-api";
import vSelect from "vue-select";
import SvgSearch from "@/assets/img/icons/search.svg";

interface InputValue {
  code: string;
}

export default defineComponent({
  name: "AmsAutoComplete",

  components: {
    vSelect,
  },

  props: {
    inputId: {
      type: String,
      required: true,
    },
    options: {
      type: Array as () => InputValue[],
      required: true,
    },
    selectedOption: {
      type: Number,
      default: -1,
    },
    placeholder: {
      type: String,
      required: false,
      default: "",
    },
    variant: {
      type: String,
      default: "outlined",
    },
    openIndicator: {
      type: Object,
      default: () => SvgSearch,
    },
  },

  setup (props, ctx) {
    const inputValue: Ref<null|InputValue> = ref(null);

    watchEffect(() => {
      if (inputValue.value) {
        inputValue.value = props.options[props.selectedOption] || null;
      }
    });

    function onInput ($event: Event) {
      if (inputValue.value) {
        ctx.emit("gotInput", { $event, value: inputValue.value.code, id: props.inputId });
      } else {
        ctx.emit("gotInput", { $event, value: "", id: props.inputId });
      }
    }

    return {
      inputValue,
      onInput,
    };
  },
});
</script>

<style lang="postcss" module>
.no-results {
  @apply flex justify-center items-center bg-gray-200 h-8;
}
</style>

<style lang="postcss">
.inputauto {
  &.v-select.vs--open {
    .vs__open-indicator {
      @apply hidden;
    }
  }

  &.outlined {
    .vs__selected-options {
      .vs__selected {
        width: calc(100% - 60px);
      }
    }
  }
}
</style>
